import { Hono } from "hono/tiny";
import { createRoute } from "../../modules/api-utils/createRoute";
import { credentials } from "../../managers/credentials";
import { apiResponse } from "../../modules/api-utils/apiResponse";
import { ContentfulStatusCode } from "hono/utils/http-status";
import { authMiddleware } from "../middleware/authorization";
import { processObjectValuePerms } from "../../modules/permission-utils/processObjectPermissions";

/* /v1/credential/:id */
export default createRoute(
  "get",
  ["/credentials/:id"],

  async (c) => {
    const credential = await credentials.fetch(c.req.param("id"));
    const gatedData = await processObjectValuePerms(
      credential.toJson(),
      "obj.credential",
      c.get("user"),
    );

    const response = apiResponse.successful(
      "Credential Fetched Successfully!",
      gatedData,
    );
    return c.json(response, response.status as ContentfulStatusCode);
  },
  authMiddleware({ permissions: ["credential.fetch"] }),
);
